"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var hooks = {};
var Events = {
  addEvent: function addEvent(event, callback) {
    if (typeof event !== 'string') {
      throw new Error('event is not a string');
    }

    if (typeof callback !== 'function') {
      throw new Error('callback is not a function');
    }

    if (!(hooks[event] instanceof Array)) {
      hooks[event] = [];
    }

    hooks[event].push(callback);
  },
  removeEvent: function removeEvent(event, callback) {
    if (hooks[event] instanceof Array) {
      var index = hooks[event].indexOf(callback);

      if (index !== -1) {
        hooks[event].splice(index, 1);
      }
    }
  },
  triggerEvent: function triggerEvent() {
    var event = arguments[0];
    var thisObj = arguments[1];

    if (hooks.hasOwnProperty(event)) {
      for (var i = 0; i < hooks[event].length; i += 1) {
        hooks[event][i].call(thisObj);
      }
    }
  }
};
var _default = Events;
exports["default"] = _default;