"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _Events = _interopRequireDefault(require("./Events"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var Route = /*#__PURE__*/function () {
  function Route(path, options) {
    _classCallCheck(this, Route);

    options = options || {};
    /**
     * Route callback
     * @type {function|null}
     */

    this.action = options.action;
    /**
     * Route events
     * @type {{}}
     */

    this.events = {};
    /**
     * Route name
     * @type {string|null}
     */

    this.name = options.name;
    /**
     * Route params
     * @type {null}
     */

    this.params = null;
    /**
     * Route path
     * @type {string}
     */

    this.path = path;
    /**
     * The router object
     * @type {Router}
     */

    this.router = options.router;
  }
  /**
   * Hooks a callback to an event
   * @param event
   * @param callback
   */


  _createClass(Route, [{
    key: "on",
    value: function on(event, callback) {
      if (event === 'leave') {
        this.events.leave = callback;
      }
    }
    /**
     * Redirects to another route
     * @param path
     */

  }, {
    key: "redirect",
    value: function redirect(path) {
      this.router.go(path);
    }
    /**
     * Renders a route content
     * @param content
     * @param options
     */

  }, {
    key: "render",
    value: function render(content, options) {
      options = options || {};
      var route = this;
      var data = {};
      var target = options.target || this.router.getTarget(); // Find the target element

      if (typeof target === 'string') {
        target = document.getElementById(target);
      } // Check target


      if (!(target instanceof Element)) {
        throw new Error('Target is not valid for route : ' + route.path);
      } // Merge data


      if (options.data) {
        if (typeof options.data === 'function') {
          data = options.data.call(route);
        } else if (_typeof(options.data) === 'object') {
          for (var key in options.data) {
            if (options.data.hasOwnProperty(key)) {
              data.key = options.data[key];
            }
          }
        }
      } // Execute before render callbacks


      _Events["default"].triggerEvent('beforeRender', this); // Remove the previous content


      target.innerHTML = ''; // Render the template

      this.router.render.call(route, content, data, target); // Update all links in the page

      this.router.parseLinks(); // Execute before render callbacks

      _Events["default"].triggerEvent('afterRender', this);
    }
  }]);

  return Route;
}();

var _default = Route;
exports["default"] = _default;